<template>
 <q-drawer v-model="rightDrawerOpen" side="right" overlay elevated bordered :width="700">
        <div class="fit column no-wrap justify-start items-center content-center">
          <div class="item col-auto text-h7">Test details</div>
          <div class="item col-auto text-h4">Foo bar{{active.suitename}}</div>
          <div class="item col-auto text-subtitle1">{{active.name}}</div>
          <div class="item horizontal-container">
          <horizontalBarTestSummary />
          </div>
          <div class="item col-auto"><bubbleChartTestExecution /> </div>
	  <div class="item col-auto"><tableSoftBisect :bisect="bisect" /> </div>
          <div class="item col-auto"><tabTestDetails /> </div>
        </div>
        <div class="q-mini-drawer-hide absolute" style="top: 15px; left: -17px">
          <q-btn
            dense
            round
            unelevated
            color="dark"
            icon="chevron_right"
            @click="rightDrawerOpen = false"
          />
        </div>
  </q-drawer>
</template>

<script>
import { ref } from 'vue'
import horizontalBarTestSummary from '@/components/charts/horizontalBarTestSummary.vue'
import bubbleChartTestExecution from '@/components/charts/bubbleChartTestExecution.vue'
import tableSoftBisect from '@/components/tables/tableSoftBisect.vue'
import tabTestDetails from '@/components/tabs/tabTestDetails.vue'

const conf = config()

export default {
  components: {
    horizontalBarTestSummary,
    bubbleChartTestExecution,
    tabTestDetails,
    tableSoftBisect
  },

  setup () {
    const rightDrawerOpen = ref(false)
    return {
      rightDrawerOpen
    }
  }, 

  data () {
    return {
       active: {},
       series: [],
       bisect: [],
       chartOptions: {
         colors: ['#f2c037', '#21ba45', '#c10015', '#26a69a'],
         chart: {
           id: "vuechart-test-detail",
         },
         stroke: {
           width: 4,
           curve: 'smooth'
         },
         labels: ["Failed", "Success", "Error", "Skipped"],
         legend: {
           show: false,
           position: 'bottom',
           onItemHover: {
             highlightDataSeries: true,
           },
           onItemClick: {
             toggleDataSeries: true,
           }
         },
         plotOptions: {
           pie: { donut: { size: 50 } } 
         }
      } 
    }
  },
  created () {
    // For now we are using a global pub/sub bus.
    // Probably vue3.js has some 'best practices' here.
    this.emitter.on('tests.summary.selected', (value) => {
        this.active = value
        this.rightDrawerOpen = true
        let project_id = this.$route.params.id
        fetch(conf.I4C_API_SERVER + "/projects/" + project_id + "/tests/" + value.id)
           .then(response => response.json())
           .then(data => (this.update(data)));
    })
  },

  methods: {
     update (data) {
        this.bisect = data.soft_bisect
        console.log("testInfo Panel", data)
     }
  }
}
</script>

<style>
.item {
 min-width: 90%;
 max-width: 95%;
 margin-top: 10px;
}

.horizontal-container {
  max-height: 50px;
}
</style>
